using System;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
[Serializable]
public class SerializableClass {
	static readonly SerializableClass static_field = new SerializableClass(1);
	int data;
	public SerializableClass(int data) {
		Data = data;
	}
	public int Data {
		get {
			return data;
		}
		set {
			data = value;
		}
	}
	public static SerializableClass StaticProperty {
		get {
			return static_field;
		}
	}
}
public class StaticFieldSerializeTest {
	static void Main() {
		const string FILENAME = "statictest.bin";
		SerializableClass sc = SerializableClass.StaticProperty, deserialized_sc;
		BinaryFormatter bf = new BinaryFormatter();
		using (FileStream fs = File.OpenWrite(FILENAME)) {
			bf.Serialize(fs, sc);
		}
		using (FileStream fs = File.OpenRead(FILENAME)) {
			deserialized_sc = (SerializableClass)bf.Deserialize(fs);
		}
		Console.WriteLine("Original : {0}, Deserialized : {1}", sc.Data, deserialized_sc.Data);
		Console.WriteLine(sc == deserialized_sc);
	}
}
