using System;
using System.Reflection;
public interface IDesigner {
	void ChangeData(Control ctrl, int data);
}
public class Control {
	int data;
	public int Data {
		get {
			return data;
		} set {
			data = value;
		}
	}
}
public class Test {
	static void Usage() {
		Console.WriteLine("Usage:\n\tTest TypeName AssemblyName");
	}
	static int Main(string[] args) {
		Control ctrl = new Control();
		if (args.Length != 2) {
			Console.WriteLine("Error : Argument length is not correct.");
			Console.WriteLine();
			return 1;
		}
		string type_name = args[0], asm_name = args[1], fullname = type_name + ", " + asm_name;
		Type type = Type.GetType(fullname);
		if (type == null) {
			Console.WriteLine("Error : Failed to get type from : \"{0}\"", fullname);
			Console.WriteLine();
			return 2;
		}
		object obj = type.InvokeMember(null, BindingFlags.Public | BindingFlags.Instance | BindingFlags.CreateInstance, null, null, null);
		IDesigner des = obj as IDesigner;
		if (des == null) {
			Console.WriteLine("Error : Type \"{0}\" is not IDesigner.", fullname);
			Console.WriteLine();
			return 3;
		}
		int org_data = ctrl.Data, new_data;
		des.ChangeData(ctrl, 5);
		new_data = ctrl.Data;
		Console.WriteLine("Original Data : {0}, New Data : {1}", org_data, new_data);
		return 0;
	}
}
