using System;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
[Serializable]
public class SerializableClass {
	private int data;
	public SerializableClass(int data) {
		this.data = data;
	}
	public int Data {
		get {
			return data;
		}
		set {
			data = value;
		}
	}
}
public class SerializeTest {
	static void Main() {
		const string FILENAME = "test.bin";
		SerializableClass sc = new SerializableClass(2), deserialized_sc;
		BinaryFormatter bf = new BinaryFormatter();
		using (FileStream fs = File.OpenWrite(FILENAME)) {
			bf.Serialize(fs, sc);
		}
		using (FileStream fs = File.OpenRead(FILENAME)) {
			deserialized_sc = (SerializableClass)bf.Deserialize(fs);
		}
		Console.WriteLine("Original : {0}, Deserialized : {1}", sc.Data, deserialized_sc.Data);
	}
}
